\ START:IF
\ Traffic light "sensor" via IF
\ Valid signals: 0 - red, 1 - yellow, 2 - green
0 CONSTANT RED-TL 
1 CONSTANT YELLOW-TL
2 CONSTANT GREEN-TL
: TL ( n -- )
  DUP \ Duplication needed to enable further comparisons
  RED-TL = IF
    ." STOP"  
  ELSE
    DUP \ Same here
    YELLOW-TL = IF
      ." WAIT"
    ELSE 
      GREEN-TL = IF
	." GO"
      ELSE
	." ERROR"
      THEN
    THEN
  THEN ;
\ END:IF

\ START:CASE
\ Traffic light "sensor" via CASE
: TL-1 ( n -- )
  CASE RED-TL    OF ." STOP" ENDOF
       YELLOW-TL OF ." WAIT" ENDOF
       GREEN-TL  OF ." GO"   ENDOF
       ." ERROR" ENDCASE ; \ default code
\ END:CASE
