      ∇NN←GENSIM MTX;MINEPS;MAXITER;ITER;S2;MTX1;MTX2;N;M;NN;MM;NP;EPS;MORE
[1] MINEPS←1E¯6 ⍝ Initialize precision
[2] MAXITER←50 ⍝ Initialize max number of iterations
[3] ITER←0
[4] S2←(⍴MTX)[2] ⍝ Data size
[5] MTX1←MTX-[1]+/MTX÷S2 ⍝ Normalize the matrix two ways
[6] MTX2←⍉MTX-[2](+/[1]MTX)÷(⍴MTX)[1]
[7] NN←(S,S)⍴1,S2⍴0 ⍝ New metric matrix: an "eye"

[8] LOOP: ⍝ Beginning of the "while" loop
[9] MM←MTX1+.×NN+.×⍉MTX1 ⍝ Update metric matrix
[10] M←(1 1⍉MM)*.5 ⍝ Normalize it
[11] MM←(MM÷[1]M)÷[2]M
[12] NP←MTX2+.×MM+.×⍉MTX2 ⍝ Update metric matrix
[13] N←(1 1⍉NP)*.5 ⍝ Normalize it
[14] NP←(NP÷[1]N)÷[2]N
[15] EPS←⌈/,|NP-NN ⍝ Calculate accuracy
[16] NN←NP
[17] ITER←ITER+1
[18] MORE←(EPS>MINEPS)∧ITER<MAXITER
[19] →MORE/LOOP ⍝ End of the "while" loop
[20] ∇
